/*   
Display DOGM128 (SPIC) mit Atxmega128A3, Atxmega128A1  intern 16 MHz

Library von Jan M. fr EA-DOGM Grafikdisplays inkl. Font-Generator
http://www.mikrocontroller.net/topic/144500#1661857
	

		Atxmega128a3							DOGM128/DOGM132
----------------------------------------------------------------------
LCD_A0      2     // PC2 (Pin 18) -> Display A0					PIN 38
LCD_RST     3     // PC3 (Pin 19) -> Display RST				PIN 39 
LCD_CS      4     // PC4 (Pin 20) -> Display CS1B				PIN 40 
SPI_MOSI    5     // PC5 (Pin 21) -> SPI MOSI					PIN 36
SPI_MISO    6     // PC6 (Pin 22) -> SPI MISO					leer
SPI_SCK     7     // PC7 (Pin 23) -> SPI SCK					PIN 37

*/


#include "tools.h"



//*****************************************************************************************************************
int main(void){

// 32Mhz kallibriert
//-----------------------------------------------------------------------------
  		OSC.CTRL = OSC_RC32MEN_bm | OSC_RC32KEN_bm;
   		while(!(OSC.STATUS & OSC_RC32MRDY_bm));
  		while(!(OSC.STATUS & OSC_RC32KRDY_bm));
		/* Start Calibrating the 32MHz Clock using * the internal calibrated 32kHz Oscillator */
 		OSC.DFLLCTRL = (0 << OSC_RC32MCREF_bp);
  		DFLLRC32M.CTRL = DFLL_ENABLE_bm;
   		CCP = CCP_IOREG_gc;
  		CLK.CTRL = CLK_SCLKSEL_RC32M_gc;
		CLKSYS_Prescalers_Config( CLK_PSADIV_2_gc, CLK_PSBCDIV_1_1_gc ); //32mhz //#define CPU_SPEED   32000000 beachten
																		// TWI Speed ?? beachten
//-----------------------------------------------------------------------------


	
	sei(); 
	
	PMIC.CTRL |= PMIC_HILVLEN_bm; 
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	PMIC.CTRL |= PMIC_LOLVLEN_bm;

	SPI_PORT_Init(); 	// SPI Port Init
 	SPI_Init();			// SPI Init
	lcd_init();			// DOGM Init
	delay_ms(100);  	// 100ms warten Display Init  //in der avr_compiler.h definiert


	lcd_set_font(FONT_FIXED_8  ,NORMAL); 	// FONT_FIXED_8 FONT_PROP_8, FONT_PROP_8, FONT_DIGITS_24 usw 
	xfunc_out = (void (*)(char))lcd_putc; 	// Xprintf(..) mit Ausgabe (SPI DOGM132) verbinden
											// Fonts mssen im Makefile benannt werden
											// Bei normalen LCD Ausgaben knne die Fonts im Befehl benannt werden
											// z.B. lcd_put_float(FONT_PROP_8 ,NORMAL,test3);
											// z.B. lcd_put_float(FONT_FIXED_8 ,NORMAL,test3);
	//LCD-Ausgabe testen
	
	float test   = 100;
	float test1 = 1000;
	float test3;

	test3=test-test1;
	lcd_moveto_xy(0,24); lcd_put_float(FONT_PROP_8 ,NORMAL,test3); // float testen

	lcd_moveto_xy(2,0);	 lcd_put_string(FONT_PROP_16 ,NORMAL,"DOGM128"); // Diverse Zeichen , String
	lcd_moveto_xy(0,0);	 lcd_put_string(FONT_FIXED_8 ,NORMAL,"1234567890123456789XX"); // Diverse Zeichen , String


	lcd_moveto_xy(5,40); xprintf(PSTR("dezimal = %d "),100);	// FONT_FIXED_8

	//lcd_put_clear(); lsch das ganze Display
		  	
	//lcd_put_clear_pw(0,7,0,127);// clear startpage 0 -> page 7, startwith 0 -> with 127 macht alles leer!
	
	/*	0 -127 Zeile
	0	xxxxxxxxxx
		x
		x
page    x
		x
		x
		x
	7	x


	*/
		
		while(true) 
		{  
			nop();
			delay_ms(250);  	// delay_ms/delay(s) in der avr_compiler.h definiert
		}



return 0;
}
