

#ifndef __SPIC_H
#define __SPIC_H


//*----------------------------------------------------------------------------
// SPIC.C Atxmega128a3 kompatible zu (Atxmega128a1 PIN beachten!!!) 
//*----------------------------------------------------------------------------
#include "tools.h"
//*----------------------------------------------------------------------------
// SPI-Bus initialisieren
//*----------------------------------------------------------------------------
#define LCD_A0      2  	// PC2 (Pin 18) = Display A0			->		PIN 38
#define LCD_RST     3   // PC3 (Pin 19) = Display RST			->		PIN 39 
#define LCD_CS      4   // PC4 (Pin 20) = Display CS1B		 	->   	PIN 40 
#define SPI_MOSI    5   // PC5 (Pin 21) = SPI MOSI				->		PIN 36
#define SPI_MISO    6   // PC6 (Pin 22) = SPI MISO				-> 		leer
#define SPI_SCK     7   // PC7 (Pin 23) = SPI SCK				->		PIN 37


void SPI_Init(void) // DOGM132 mit SPIC
{
	
	SPIC.CTRL =  SPI_MODE_3_gc | SPI_PRESCALER_DIV16_gc | (1<< SPI_CLK2X_bp) | (1<< SPI_ENABLE_bp) | (1<< SPI_MASTER_bp);
	SPIC.INTCTRL = SPI_INTLVL_OFF_gc;
	SPIC.STATUS = 0;


//	sollte SPI gewechselt werden
//	SPID.CTRL =  SPI_MODE_3_gc | SPI_PRESCALER_DIV16_gc | (1<< SPI_CLK2X_bp) | (1<< SPI_ENABLE_bp) | (1<< SPI_MASTER_bp);
//	SPID.INTCTRL = SPI_INTLVL_OFF_gc;
//	SPID.STATUS = 0;



}

void SPI_PORT_Init(void)
{
	// === PORT-B CONFIG ===
	PORTC_DIRSET  = (1 << SPI_MOSI) | (1 << SPI_SCK)  | (1 << LCD_CS) | (1 << LCD_RST) | (1 << LCD_A0);
	PORTC_DIRCLR  = (1 << SPI_MISO);    
	PORTC_OUTSET  = (1 << SPI_MISO) | (1 << SPI_MOSI) | (1 << SPI_SCK)  | (1 << LCD_CS) | (0 << LCD_RST) | (1 << LCD_A0);
	//PORTC.PIN4CTRL 	=  PORT_OPC_PULLUP_gc;
}


#endif
