//*----------------------------------------------------------------------------
// TYPEDEFS.H
//*----------------------------------------------------------------------------
#ifndef __TYPEDEFS_H
#define __TYPEDEFS_H
//*----------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
//*----------------------------------------------------------------------------
#define FALSE 0
#define false 0
#define TRUE  1
#define true  1
//*----------------------------------------------------------------------------
#define BIT0  0x00000001
#define BIT1  0x00000002
#define BIT2  0x00000004
#define BIT3  0x00000008
#define BIT4  0x00000010
#define BIT5  0x00000020
#define BIT6  0x00000040
#define BIT7  0x00000080
#define BIT8  0x00000100
#define BIT9  0x00000200
#define BIT10 0x00000400
#define BIT11 0x00000800
#define BIT12 0x00001000
#define BIT13 0x00002000
#define BIT14 0x00004000
#define BIT15 0x00008000
#define BIT16 0x00010000
#define BIT17 0x00020000
#define BIT18 0x00040000
#define BIT19 0x00080000
#define BIT20 0x00100000
#define BIT21 0x00200000
#define BIT22 0x00400000
#define BIT23 0x00800000
#define BIT24 0x01000000
#define BIT25 0x02000000
#define BIT26 0x04000000
#define BIT27 0x08000000
#define BIT28 0x10000000
#define BIT29 0x20000000
#define BIT30 0x40000000
#define BIT31 0x80000000
//*----------------------------------------------------------------------------
#define  BIT(n)   (1 << (n))
#define  NOBIT(n) (0 << (n))
#define  TEST_BIT(entity, bitmask)   ((entity) & (bitmask))
#define  SET_BIT(entity, bitmask)    ((entity) |= (bitmask))
#define  CLEAR_BIT(entity, bitmask)  ((entity) &= ~(bitmask))
//*----------------------------------------------------------------------------
// Typendeklarationen
//*----------------------------------------------------------------------------
typedef signed char S8; // Wertebereich: -128..127
typedef signed char s8; // Wertebereich: -128..127
typedef signed char S08;
typedef signed char tS08;
typedef unsigned char U8; // Wertebereich: 0..255
typedef unsigned char u8; // Wertebereich: 0..255
typedef unsigned char U08;
typedef unsigned char tU08;
typedef volatile signed char vs8; // Wertebereich: -128..127
typedef volatile unsigned char vu8; // Wertebereich: -128..127

typedef signed int S16; // Wertebereich: -32768..32767
typedef signed int s16; // Wertebereich: -32768..32767
typedef signed int tS16;
typedef unsigned int U16; // Wertebereich: 0..65535
typedef unsigned int u16; // Wertebereich: 0..65535
typedef unsigned int tU16;
typedef volatile signed int vs16;
typedef volatile unsigned int vu16;

typedef signed long S32; // Wertebereich: -2147483648..2147483647
typedef signed long s32; // Wertebereich: -2147483648..2147483647
typedef signed long tS32;
typedef unsigned long U32; // Wertebereich: 0..4294967295
typedef unsigned long u32; // Wertebereich: 0..4294967295
typedef unsigned long tU32;

typedef signed long long S64;
typedef signed long long tS64;
typedef unsigned long long U64;
typedef unsigned long long tU64;

typedef S08 *pS8;
typedef S08 *pS08;
typedef U08 *pU8;
typedef U08 *pU08;
typedef S16 *pS16;
typedef U16 *pU16;
typedef S32 *pS32;
typedef U32 *pU32;
typedef S64 *pS64;
typedef U64 *pU64;
typedef float *pfloat;
typedef double *pdouble;
typedef U8 BOOL;
typedef BOOL *pBOOL;

//*----------------------------------------------------------------------------
typedef union uMEM08 // 8-Bit Datentyp mit Byte- und Bitzugriff
{                    // Zugriff auf Byte var.U08 = 0xFF;
  U8 U8;             // Zugriff auf Bit var.bit._7 = 1;

  struct
  {
    U8 _0: 1;
    U8 _1: 1;
    U8 _2: 1;
    U8 _3: 1;
    U8 _4: 1;
    U8 _5: 1;
    U8 _6: 1;
    U8 _7: 1;
  } bit;

} tMEM08;
//*----------------------------------------------------------------------------
typedef union uMEM16 // 16-Bit Datentyp mit Wort- und Bytezugriff
{                    // Zugriff auf Wort var.U16 = 0xAA55;
  U16 U16;           // Zugriff auf Byte var.U08._0 = 0xFF;

  struct
  {
    U8 LO; // LSB
    U8 HI; // MSB
  } U8;

} tMEM16;
//*----------------------------------------------------------------------------
typedef union uMEM32 // 32-Bit Datentyp mit Byte-, Wort- und Zeigerzugriff
{
  U32 U32;    // Zugriff auf DWORD var.U32 = 0x4000AA55;
  pU32 pU32;  // Zeiger auf U32


  struct // Zugriff auf Word: var.U16._0 = 0xABCD;
  {
    U16 _0; // LSW
    U16 _1; // MSW
  } U16;

  struct // Zugriff auf Byte var.U08._0 = 0xFF;
  {
    U8 _0; // LSB
    U8 _1;
    U8 _2;
    U8 _3; // MSB
  } U8;

} tMEM32;
//*----------------------------------------------------------------------------
#endif
